/**********************************************************************
 *
 * querycache.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: querycache.h 110 1999-01-08 09:02:22Z rjmcnab $
 *
 *********************************************************************/


#ifndef QUERYCACHE_H
#define QUERYCACHE_H


#include "text_t.h"
#include "queryinfo.h"

class resultcacheel
{
public:
  resultcacheel ();

  int accessnum;
  queryparamclass queryparameters;
  queryresultsclass queryresults;
};


class querycache {
public:
  querycache (int themaxcachesize);
  ~querycache ();

  // returns true if the query was found in the cache
  // if the query was found then queryresults contains
  // the results
  bool find (const queryparamclass &queryparams, 
	     queryresultsclass &queryresults);

  void cache (const queryparamclass &queryparams,
	    const queryresultsclass &queryresults);

protected:
  resultcacheel *resultcache;

  int maxcachesize;
  int nextaccessnum;
  
  int getnextaccessnum ();
  int getfreecachenum ();
};


#endif
