/**********************************************************************
 *
 * phrasesearch.h -- tools to search for a phrase in a larger text
 * Copyright (C) 1999  DigiLib Systems Limited
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: phrasesearch.h 395 1999-07-16 00:15:49Z sjboddie $
 *
 *********************************************************************/


#ifndef PHRASESEARCH_H
#define PHRASESEARCH_H


#include "text_t.h"
#include "unitool.h"
#include "mgsearch.h"
#include "infodbclass.h"


// looks for the phrase in the metadata or text associated with
// a document number. This function has not been coded with all
// situations in mind and expects mgsearch and gdbm set up ready to go
bool OID_phrase_search (mgsearchclass &mgsearch,
			gdbmclass &gdbm,
			const text_t &index,
			const text_t &subcollection,
			const text_t &language,
			const text_t &longindex,
			const text_t &collection,
			const termfreqclassarray &phrase,
			int docnum);

#endif
